OpenTTD Source: src/newgrf_gui.cpp File Reference

OpenTTD Source 14.0-RC3

Data Structures | Typedefs | Functions | Variables
newgrf_gui.cpp File Reference
`#include "stdafx.h"`
`#include "error.h"`
`#include "settings_gui.h"`
`#include "newgrf.h"`
`#include "strings_func.h"`
`#include "window_func.h"`
`#include "gamelog.h"`
`#include "settings_type.h"`
`#include "settings_func.h"`
`#include "widgets/dropdown_type.h"`
`#include "widgets/dropdown_func.h"`
`#include "network/network.h"`
`#include "network/network_content.h"`
`#include "sortlist_type.h"`
`#include "stringfilter_type.h"`
`#include "querystring_gui.h"`
`#include "core/geometry_func.hpp"`
`#include "newgrf_text.h"`
`#include "textfile_gui.h"`
`#include "tilehighlight_func.h"`
`#include "fios.h"`
`#include "timer/timer.h"`
`#include "timer/timer_window.h"`
`#include "zoom_func.h"`
`#include "widgets/newgrf_widget.h"`
`#include "widgets/misc_widget.h"`
`#include "table/sprites.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
struct | NewGRFParametersWindow
| Window for setting the parameters of a NewGRF. More...
struct | NewGRFTextfileWindow
| Window for displaying the textfile of a NewGRF. More...
struct | NewGRFWindow
| Window for showing NewGRF files. More...
class | NWidgetNewGRFDisplay
| Custom nested widget container for the NewGRF gui. More...
struct | SavePresetWindow
| Class for the save preset window. More...
struct | ScanProgressWindow
| Window for showing the progress of NewGRF scanning. More...

## Typedefs
typedef std::map< uint32_t, const GRFConfig * > | GrfIdMap
| Map of grfid to the grf config.

## Functions
void | ShowNewGRFError ()
| Show the first NewGRF error we can find.
static void | ShowNewGRFInfo (const GRFConfig *c, const Rect &r, bool show_params)
void | OpenGRFParameterWindow (bool is_baseset, GRFConfig *c, bool editable)
void | ShowNewGRFTextfileWindow (TextfileType file_type, const GRFConfig *c)
static void | FillGrfidMap (const GRFConfig *c, GrfIdMap *grfid_map)
| Add all grf configs from c into the map. More...
static void | NewGRFConfirmationCallback (Window *w, bool confirmed)
| Callback function for the newgrf 'apply changes' confirmation window. More...
static void | ShowSavePresetWindow (const char *initial_text)
| Open the window for saving a preset. More...
void | ShowMissingContentWindow (const GRFConfig *list)
| Show the content list window with all missing grfs from the given list. More...
std::unique_ptr< NWidgetBase > | NewGRFDisplay ()
| Construct nested container widget for managing the lists and the info panel of the NewGRF GUI.
void | ShowNewGRFSettings (bool editable, bool show_params, bool exec_changes, GRFConfig **config)
| Setup the NewGRF gui. More...
void | UpdateNewGRFScanStatus (uint num, const char *name)
| Update the NewGRF scan status. More...

## Variables
static constexpr NWidgetPart | _nested_newgrf_parameter_widgets []
static WindowDesc | _newgrf_parameters_desc (__FILE__, __LINE__, WDP_CENTER, "settings_newgrf_config", 500, 208, WC_GRF_PARAMETERS, WC_NONE, 0, std::begin(_nested_newgrf_parameter_widgets), std::end(_nested_newgrf_parameter_widgets))
| Window definition for the change grf parameters window.
static constexpr NWidgetPart | _nested_newgrf_actives_widgets []
static constexpr NWidgetPart | _nested_newgrf_availables_widgets []
static constexpr NWidgetPart | _nested_newgrf_infopanel_widgets []
static constexpr NWidgetPart | _nested_newgrf_widgets []
static WindowDesc | _newgrf_desc (__FILE__, __LINE__, WDP_CENTER, "settings_newgrf", 300, 263, WC_GAME_OPTIONS, WC_NONE, 0, std::begin(_nested_newgrf_widgets), std::end(_nested_newgrf_widgets))
static constexpr NWidgetPart | _nested_save_preset_widgets []
| Widget parts of the save preset window. More...
static WindowDesc | _save_preset_desc (__FILE__, __LINE__, WDP_CENTER, "save_preset", 140, 110, WC_SAVE_PRESET, WC_GAME_OPTIONS, WDF_MODAL, std::begin(_nested_save_preset_widgets), std::end(_nested_save_preset_widgets))
| Window description of the preset save window.
static constexpr NWidgetPart | _nested_scan_progress_widgets []
| Widgets for the progress window. More...
static WindowDesc | _scan_progress_desc (__FILE__, __LINE__, WDP_CENTER, nullptr, 0, 0, WC_MODAL_PROGRESS, WC_NONE, 0, std::begin(_nested_scan_progress_widgets), std::end(_nested_scan_progress_widgets))
| Description of the widgets and other settings of the window.

## Detailed Description

GUI to change NewGRF settings.

Definition in file newgrf_gui.cpp.

## Function Documentation

## ◆ FillGrfidMap()

static void FillGrfidMap | ( | const GRFConfig * | c,
|  | GrfIdMap * | grfid_map
| ) |  |
| static

Add all grf configs from c into the map.

Parameters

  c | Grf list to add.
  grfid_map | Map to add them to.

Definition at line 591 of file newgrf_gui.cpp.

References GRFIdentifier::grfid, GRFConfig::ident, and GRFConfig::next.

Referenced by NewGRFWindow::CanUpgradeCurrent(), and NewGRFWindow::UpgradeCurrent().

## ◆ NewGRFConfirmationCallback()

static void NewGRFConfirmationCallback | ( | Window * | w,
|  | bool | confirmed
| ) |  |
| static

Callback function for the newgrf 'apply changes' confirmation window.

Parameters

  w | Window which is calling this callback
  confirmed | boolean value, true when yes was clicked, false otherwise

Definition at line 1983 of file newgrf_gui.cpp.

References _gamelog, _grfconfig, NewGRFWindow::active_sel, NewGRFWindow::actives, NewGRFWindow::avails, CloseWindowByClass(), CopyGRFConfigList(), GUIList< T, P, F >::ForceRebuild(), GLAT_GRF, Gamelog::GRFUpdate(), Window::InvalidateData(), NewGRFWindow::modified, GRFConfig::next, NewGRFWindow::orig_list, ReInitAllWindows(), ReloadNewGRFData(), Gamelog::StartAction(), Gamelog::StopAction(), WC_BUILD_OBJECT, WC_GRF_PARAMETERS, and WC_TEXTFILE.

## ◆ ShowMissingContentWindow()

void ShowMissingContentWindow | ( | const GRFConfig * | list | ) |

Show the content list window with all missing grfs from the given list.

Parameters

  list | The list of grfs to check for missing / not exactly matching ones.

Definition at line 1570 of file newgrf_gui.cpp.

References BSWAP32(), CONTENT_TYPE_NEWGRF, ContentInfo::DOES_NOT_EXIST, GRFConfig::flags, GCF_COMPATIBLE, GCS_NOT_FOUND, GRFConfig::GetName(), GRFIdentifier::grfid, HasBit(), GRFConfig::ident, ContentInfo::md5sum, GRFIdentifier::md5sum, ContentInfo::name, GRFConfig::next, GRFConfig::original_md5sum, ShowNetworkContentListWindow(), ContentInfo::state, GRFConfig::status, ContentInfo::type, and ContentInfo::unique_id.

## ◆ ShowNewGRFSettings()

void ShowNewGRFSettings | ( | bool | editable,
|  | bool | show_params,
|  | bool | exec_changes,
|  | GRFConfig ** | config
| ) |  |

Setup the NewGRF gui.

Parameters

  editable | allow the user to make changes to the grfconfig in the window
  show_params | show information about what parameters are set for the grf files
  exec_changes | if changes are made to the list (editable is true), apply these changes immediately or only update the list
  config | pointer to a linked-list of grfconfig's that will be shown

Definition at line 2023 of file newgrf_gui.cpp.

References CloseWindowByClass(), and WC_GAME_OPTIONS.

## ◆ ShowSavePresetWindow()

static void ShowSavePresetWindow | ( | const char * | initial_text | ) |
| static

Open the window for saving a preset.

Parameters

  initial_text | Initial text to display in the edit box, or `nullptr`.

Definition at line 2181 of file newgrf_gui.cpp.

References CloseWindowByClass(), and WC_SAVE_PRESET.

## ◆ UpdateNewGRFScanStatus()

void UpdateNewGRFScanStatus | ( | uint | num,
|  | const char * | name
| ) |  |

Update the NewGRF scan status.

Parameters

  num | The number of NewGRFs scanned so far.
  name | The name of the last scanned NewGRF.

Definition at line 2289 of file newgrf_gui.cpp.

References FindWindowByClass(), ScanProgressWindow::UpdateNewGRFScanStatus(), and WC_MODAL_PROGRESS.

## Variable Documentation

## ◆ _nested_newgrf_widgets

constexpr NWidgetPart _nested_newgrf_widgets[]
| staticconstexpr

Initial value:
= {
NWidget(NWID_HORIZONTAL),
NWidget(WWT_CLOSEBOX, COLOUR_MAUVE),
NWidget(WWT_CAPTION, COLOUR_MAUVE), SetDataTip(STR_NEWGRF_SETTINGS_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
NWidget(WWT_DEFSIZEBOX, COLOUR_MAUVE),
EndContainer(),
NWidget(WWT_PANEL, COLOUR_MAUVE),
NWidgetFunction(NewGRFDisplay), SetPadding(WidgetDimensions::unscaled.sparse_resize),
NWidget(NWID_HORIZONTAL),
NWidget(NWID_SPACER), SetFill(1, 0), SetResize(1, 0),
NWidget(WWT_RESIZEBOX, COLOUR_MAUVE), SetDataTip(RWV_HIDE_BEVEL, STR_TOOLTIP_RESIZE),
EndContainer(),
EndContainer(),
}

Definition at line 1954 of file newgrf_gui.cpp.

## ◆ _nested_save_preset_widgets

constexpr NWidgetPart _nested_save_preset_widgets[]
| staticconstexpr

Initial value:
= {
NWidget(NWID_HORIZONTAL),
NWidget(WWT_CLOSEBOX, COLOUR_GREY),
NWidget(WWT_CAPTION, COLOUR_GREY), SetDataTip(STR_SAVE_PRESET_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
NWidget(WWT_DEFSIZEBOX, COLOUR_GREY),
EndContainer(),
NWidget(WWT_PANEL, COLOUR_GREY),
NWidget(NWID_HORIZONTAL),
NWidget(WWT_INSET, COLOUR_GREY, WID_SVP_PRESET_LIST), SetPadding(2, 1, 2, 2),
SetDataTip(0x0, STR_SAVE_PRESET_LIST_TOOLTIP), SetResize(1, 10), SetScrollbar(WID_SVP_SCROLLBAR), EndContainer(),
NWidget(NWID_VSCROLLBAR, COLOUR_GREY, WID_SVP_SCROLLBAR),
EndContainer(),
EndContainer(),
NWidget(WWT_PANEL, COLOUR_GREY),
NWidget(WWT_EDITBOX, COLOUR_GREY, WID_SVP_EDITBOX), SetPadding(2, 2, 2, 2), SetFill(1, 0), SetResize(1, 0),
SetDataTip(STR_SAVE_PRESET_TITLE, STR_SAVE_PRESET_EDITBOX_TOOLTIP),
EndContainer(),
NWidget(NWID_HORIZONTAL),
NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, WID_SVP_CANCEL), SetDataTip(STR_SAVE_PRESET_CANCEL, STR_SAVE_PRESET_CANCEL_TOOLTIP), SetFill(1, 0), SetResize(1, 0),
NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, WID_SVP_SAVE), SetDataTip(STR_SAVE_PRESET_SAVE, STR_SAVE_PRESET_SAVE_TOOLTIP), SetFill(1, 0), SetResize(1, 0),
NWidget(WWT_RESIZEBOX, COLOUR_GREY),
EndContainer(),
}

Widget parts of the save preset window.

Definition at line 2030 of file newgrf_gui.cpp.

## ◆ _nested_scan_progress_widgets

constexpr NWidgetPart _nested_scan_progress_widgets[]
| staticconstexpr

Initial value:
= {
NWidget(WWT_CAPTION, COLOUR_GREY), SetDataTip(STR_NEWGRF_SCAN_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
NWidget(WWT_PANEL, COLOUR_GREY),
NWidget(NWID_VERTICAL), SetPIP(0, WidgetDimensions::unscaled.vsep_wide, 0), SetPadding(WidgetDimensions::unscaled.modalpopup),
NWidget(WWT_LABEL, INVALID_COLOUR), SetDataTip(STR_NEWGRF_SCAN_MESSAGE, STR_NULL), SetFill(1, 0),
NWidget(WWT_EMPTY, INVALID_COLOUR, WID_SP_PROGRESS_BAR), SetFill(1, 0),
NWidget(WWT_EMPTY, INVALID_COLOUR, WID_SP_PROGRESS_TEXT), SetFill(1, 0), SetMinimalSize(400, 0),
EndContainer(),
EndContainer(),
}

Widgets for the progress window.

Definition at line 2188 of file newgrf_gui.cpp.

SetFill
constexpr NWidgetPart SetFill(uint16_t fill_x, uint16_t fill_y)
Widget part function for setting filling.
Definition: widget_type.h:1143
WID_SVP_PRESET_LIST
@ WID_SVP_PRESET_LIST
List with available preset names.
Definition: newgrf_widget.h:67
WID_SP_PROGRESS_TEXT
@ WID_SP_PROGRESS_TEXT
Text explaining what is happening.
Definition: newgrf_widget.h:77
WID_SVP_SCROLLBAR
@ WID_SVP_SCROLLBAR
Scrollbar for the list available preset names.
Definition: newgrf_widget.h:68
WWT_CAPTION
@ WWT_CAPTION
Window caption (window title between closebox and stickybox)
Definition: widget_type.h:63
WWT_LABEL
@ WWT_LABEL
Centered label.
Definition: widget_type.h:59
WWT_DEFSIZEBOX
@ WWT_DEFSIZEBOX
Default window size box (at top-right of a window, between WWT_SHADEBOX and WWT_STICKYBOX)
Definition: widget_type.h:67
NWID_HORIZONTAL
@ NWID_HORIZONTAL
Horizontal container.
Definition: widget_type.h:77
RWV_HIDE_BEVEL
@ RWV_HIDE_BEVEL
Bevel of resize box is hidden.
Definition: widget_type.h:42
EndContainer
constexpr NWidgetPart EndContainer()
Widget part function for denoting the end of a container (horizontal, vertical, WWT_FRAME,...
Definition: widget_type.h:1153
WWT_EMPTY
@ WWT_EMPTY
Empty widget, place holder to reserve space in widget tree.
Definition: widget_type.h:50
NewGRFDisplay
std::unique_ptr< NWidgetBase > NewGRFDisplay()
Construct nested container widget for managing the lists and the info panel of the NewGRF GUI.
Definition: newgrf_gui.cpp:1944
NWidgetFunction
constexpr NWidgetPart NWidgetFunction(NWidgetFunctionType *func_ptr)
Obtain a nested widget (sub)tree from an external source.
Definition: widget_type.h:1281
WID_SVP_CANCEL
@ WID_SVP_CANCEL
Button to cancel saving the preset.
Definition: newgrf_widget.h:70
SetPadding
constexpr NWidgetPart SetPadding(uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
Widget part function for setting additional space around a widget.
Definition: widget_type.h:1190
SetResize
constexpr NWidgetPart SetResize(int16_t dx, int16_t dy)
Widget part function for setting the resize step.
Definition: widget_type.h:1088
SetScrollbar
constexpr NWidgetPart SetScrollbar(WidgetID index)
Attach a scrollbar to a widget.
Definition: widget_type.h:1246
WWT_EDITBOX
@ WWT_EDITBOX
a textbox for typing
Definition: widget_type.h:73
WWT_PUSHTXTBTN
@ WWT_PUSHTXTBTN
Normal push-button (no toggle button) with text caption.
Definition: widget_type.h:110
NWidget
constexpr NWidgetPart NWidget(WidgetType tp, Colours col, WidgetID idx=-1)
Widget part function for starting a new 'real' widget.
Definition: widget_type.h:1260
NWID_VERTICAL
@ NWID_VERTICAL
Vertical container.
Definition: widget_type.h:79
WidgetDimensions::unscaled
static const WidgetDimensions unscaled
Unscaled widget dimensions.
Definition: window_gui.h:67
WWT_CLOSEBOX
@ WWT_CLOSEBOX
Close box (at top-left of a window)
Definition: widget_type.h:71
WWT_RESIZEBOX
@ WWT_RESIZEBOX
Resize box (normally at bottom-right of a window)
Definition: widget_type.h:70
WID_SP_PROGRESS_BAR
@ WID_SP_PROGRESS_BAR
Simple progress bar.
Definition: newgrf_widget.h:76
NWID_VSCROLLBAR
@ NWID_VSCROLLBAR
Vertical scrollbar.
Definition: widget_type.h:86
WID_SVP_SAVE
@ WID_SVP_SAVE
Button to save the preset.
Definition: newgrf_widget.h:71
SetPIP
constexpr NWidgetPart SetPIP(uint8_t pre, uint8_t inter, uint8_t post)
Widget part function for setting a pre/inter/post spaces.
Definition: widget_type.h:1222
WID_SVP_EDITBOX
@ WID_SVP_EDITBOX
Edit box for changing the preset name.
Definition: newgrf_widget.h:69
WWT_PANEL
@ WWT_PANEL
Simple depressed panel.
Definition: widget_type.h:52
NWID_SPACER
@ NWID_SPACER
Invisible widget that takes some space.
Definition: widget_type.h:81
WWT_INSET
@ WWT_INSET
Pressed (inset) panel, most commonly used as combo box text area.
Definition: widget_type.h:53
SetMinimalSize
constexpr NWidgetPart SetMinimalSize(int16_t x, int16_t y)
Widget part function for setting the minimal size.
Definition: widget_type.h:1099
SetDataTip
constexpr NWidgetPart SetDataTip(uint32_t data, StringID tip)
Widget part function for setting the data and tooltip.
Definition: widget_type.h:1164